<?php
$field = $context['field'];

if (isset($field->options)) {
    $options = $field->options;
}
$uid = uniqid('twwf_dropdown_');
$field_uid = uniqid('twwf_dropdown_list');

?>

<?php if (isset($options)) { ?>
    <div class="tww_filter_field_block">
        <div class="twwf_field_header">
            <span class="tww_filter_field_title"><?php echo esc_html($field->name); ?></span>
            <span data-field_id="<?php echo esc_attr($field_uid); ?>" class="twwf_open_close_field"></span>
        </div>
        <div id="<?php echo esc_attr($field_uid); ?>" class="twwf_dropdown_list twwf_filter_field">
            <select class="twwf_dropdown tww_filter_element" id="<?php echo esc_attr($uid); ?>" name="<?php echo esc_attr($field->inputName); ?>">
                <option value="">All</option>
                <?php foreach ($options as $option) { ?>
                <?php
                if (isset($option->fieldState) && $option->fieldState === 'off') {
                    continue;
                }
                $selected = '';
                $u_id = $option->name . '_' . $option->item_id . '_' . $field->id;

                if (isset($option->checked) && $option->checked) {
                    $selected = 'selected';
                }
                ?>
                <option data-title="<?php echo esc_attr($option->name); ?>" value="<?php echo esc_attr($option->item_id); ?>" <?php echo esc_attr($selected); ?>><?php echo esc_html($option->name); ?></option>
            <?php }?>
            </select>
            <script data-two-no-delay="">
                jQuery(document).ready(function() {
                    jQuery('#<?php echo esc_attr($uid); ?>').select2({
                        minimumResultsForSearch: -1,
                    });
                });
            </script>
        </div>
    </div>
<?php }?>
