jQuery(document).ready(function() {
    let twwf_form_id = '';
    let twwf_ajax = 'yes';
    let twwf_filter_reset = false;
    jQuery('.tww_filter_form .twwf_price_slider').on( "slidechange", function( event, ui ) {
        if(twwf_filter_reset){
            return;
        }
        twwfProductsAjaxFilter(jQuery(this));
    });
    jQuery(document).on('change', '.tww_filter_form :input', function() {
        if(twwf_filter_reset){
            twwf_filter_reset = false;
            return
        }
        twwfProductsAjaxFilter(jQuery(this))
    });

    jQuery(document).on('click', '.twwf_filtered_field', function() {
        twwf_change_filter(jQuery(this));
        twwfProductsAjaxFilter(jQuery(this));
    });

    jQuery(document).on('click', '.twwf_reset_filtered_fields', function (){
        let twwf_filtered_field = jQuery(this).closest('form').find('.twwf_filtered_field');
        twwf_filtered_field.each(function (){
            twwf_change_filter(jQuery(this))
        })
        twwfProductsAjaxFilter(jQuery(this));
    })
    function twwf_set_url(){
        let origForm = jQuery('.tww_filter_form').serialize();
        let url = window.location.origin+window.location.pathname+"?"+origForm+'&twwf_submit=Filter';
        window.history.pushState({},"", url);
        return url;
    }

    function twwf_change_filter(_this){
        twwf_filter_reset = true;
        let type = _this.data('type');
        if(type === 'price'){
            let twwf_price_slider = _this.closest('form').find('.twwf_price_slider');
            let min_price = parseInt(twwf_price_slider.data('min_price'));
            let max_price = parseInt(twwf_price_slider.data('max_price'));
            let currency = twwf_price_slider.data('currency');
            _this.closest('form').find('.twwf_min_price_input').val(min_price);
            _this.closest('form').find('.twwf_max_price_input').val(max_price);
            twwf_price_slider.slider("values", [min_price, max_price]);
            twwf_price_slider.find('.ui-slider-handle').last().html('<span class="tww_handle_price">'+currency+'<span class="price">'+min_price+'</span></span>');
            twwf_price_slider.find('.ui-slider-handle').first().html('<span class="tww_handle_price">'+currency+'<span class="price">'+max_price+'</span></span>');
            return;
        }
        let value = _this.data('val');
        let name = _this.data('name');

        let input = jQuery('input[name="'+name+'"][value="'+value+'"]');
        let select = jQuery('select[name="'+name+'"]');

        input.prop('checked',false);
        select.find("option[value='"+value+"']").prop("selected", false)
        select.trigger('change');
    }

    function twwfProductsAjaxFilter(_this) {

        let twwf_main_form = _this.closest('form');
        twwf_form_id = twwf_main_form.data('id');
        twwf_ajax = twwf_main_form.data('ajax');
        if(twwf_ajax != 'yes'){
            return
        }
        let min_price = parseInt(twwf_main_form.find('.twwf_min_price_input').data('min'));
        let max_price = parseInt(twwf_main_form.find('.twwf_max_price_input').data('max'));
        let filtered_min_price = min_price;
        let filtered_max_price = max_price;

        jQuery('.twwf_filtered_field').remove();
        let filter_data_array = jQuery('.tww_filter_form').serializeArray();
        let price_title = '-'
        let currency= twwf_main_form.find('.twwf_price_slider').data('currency');
        jQuery(filter_data_array).each(function (index,element){
            let name = element.name;
            let value = element.value;
            if (name.includes('twwf') && name !='twwf_id' && name !='twwf_nonce'){
                let input = jQuery('input[name="'+name+'"][value="'+value+'"]');
                if(name.includes('min')){
                    filtered_min_price = parseInt(input.val());
                    price_title =  currency+filtered_min_price+price_title
                }else if(name.includes('max')){
                    filtered_max_price = parseInt(input.val());
                    price_title = price_title + currency+filtered_max_price
                }
                let select = jQuery('select[name="'+name+'"]');
                let title = ''
                if(input.length>0){
                    title = input.data('title');
                }else if(select.length>0){
                    let option = select.find("option[value='"+value+"']");
                    title = option.data('title');
                }
                if(title != '' && typeof title != "undefined"){
                    twwf_main_form.find('.twwf_filtered_fields').prepend('<span data-type="input" data-name="'+name+'" data-val="'+value+'" class="twwf_filtered_field">'+title+'</span>');
                }
            }
        })
        if (twwf_main_form.find('.twwf_price_slider_container').length>0 && price_title != ''  && (min_price != filtered_min_price || max_price!=filtered_max_price)){
            twwf_main_form.find('.twwf_filtered_fields').prepend('<span data-type="price" class="twwf_filtered_field">'+price_title+'</span>');
        }

        const container = jQuery('.elementor-widget-twbb_woocommerce-products');
        const container_id = jQuery('.elementor-widget-twbb_woocommerce-products').data('id');

        let url = twwf_set_url()

        jQuery.ajax({
            url: url,
            type:'GET',
            dataType: 'html',
            success: function(data){
                let parser = new DOMParser();
                const doc = parser.parseFromString(data, 'text/html');
                const new_page = jQuery(doc).find('.elementor-widget-twbb_woocommerce-products[data-id="' + container_id + '"]').html();
                if (typeof new_page == "undefined"){
                    container.html('');
                } else{
                    container.html(new_page);
                }

                jQuery('.twbb_woocommerce-products-ajax-paginate .page-numbers li').on('click', function(e) {
                    e.preventDefault();
                    productsAjaxPagination(jQuery(this));
                })
            }
        })
        if(jQuery('.twwf_filtered_field').length<1){
            jQuery('.twwf_filtered_fields').css({
                'display':'none'
            })
        }else{
            jQuery('.twwf_filtered_fields').css({
                'display':'block'
            })
        }
        twwf_filter_reset = false;

    }
});